<template>
  <q-layout view="hHh lpR fFf">
    <q-page-container>
      <q-header elevated>
        <Toolbar :pageTitle="$t('schedule_session.page_title')" />
      </q-header>

      <q-page class="pl-fullpage">
        <div class="col-12 col-md-6">
          <q-stepper v-model="formPage" flat contracted>
            <q-step title="1" :name="1" :done="formPage > 1">
              <div v-if="user.loading" class="text-center">
                <q-spinner size="lg" />
              </div>
              <ScheduleSessionFormSection1 v-else :initialName="name" :initialPrivacySelection="privacySelection"
                :requestSaveFormSection="(newName, newPrivacySelection, newDate) =>
                {
                  this.name = newName;
                  this.privacySelection = newPrivacySelection;
                  this.scheduledStartTime = newDate;
                  this.formPage++;
                }" />
            </q-step>
            <q-step title="2" :name="2" :done="formPage > 2">
              <ScheduleSessionFormSection2 :maxCapacity="50" :trunks="trunks"
                :existingEvents="upcomingConferences"
                :requestSaveFormSection="section2Complete" />
            </q-step>
            <q-step title="3" :name="3" :done="formPage > 3">
              <ScheduleSessionFormSection3 :contacts="user.Contacts || {}" :groups="user.Groups || {}"
                :participants="participants" :hostNum="user ? user.Phone : null" :capacity="capacity"
                :trunk="trunk" :requestSaveFormSection="
                  (direction, newParticipants) =>
                  {
                    participants = newParticipants;
                    if (direction == 'next')
                    {
                      this.formPage++;
                    }
                    else if (direction == 'prev')
                    {
                      this.formPage--;
                    }
                  }
                " />
            </q-step>
            <q-step title="4" :name="4" :done="formPage > 4">
              <ScheduleSessionFormSection4 :participants="participants" :agenda="agenda" :usersPhone="user.Phone"
                :canStartNow="sessionIsNow" :timeValid="sessionTimeValid" :requestSaveFormSection="finalSectionComplete" />
            </q-step>
          </q-stepper>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import ScheduleSessionFormSection1 from "../components/ScheduleSessionSection1.vue";
import ScheduleSessionFormSection2 from "../components/ScheduleSessionSection2.vue";
import ScheduleSessionFormSection3 from "../components/ScheduleSessionSection3.vue";
import ScheduleSessionFormSection4 from "../components/ScheduleSessionSection4.vue";
import { db, auth, functions } from "../firebase";
import Toolbar from "../components/Toolbar.vue";
import moment from 'moment'

export default {
  data()
  {
    return {
      name: "",
      scheduledStartTime: null,
      lengthMins: null,
      capacity: null,
      trunk: null,
      privacySelection: "open",
      formPage: 1,
      user: { loading: true },
      participants: {},
      agenda: [],
      upcomingConferences: {},
      trunks: {},
      timerInterval: 0,
      now: moment()
    };
  },
  created()
  {
    let context = this;
    this.timerInterval = setInterval(() =>
      {
        context.now = moment();
      }, 1000);

    this.$rtdbBind("user", db.ref(`Users/${auth.currentUser.uid}`))
      .then(() =>
      {
        this.participants[this.user.Phone] = {
          Name: this.user.Name,
          Moderator: true,
        };
      });

    this.fetchExisting();

    this.$rtdbBind(
      "trunks",
      db.ref("System/Trunks")
    );
  },
  beforeDestroy()
  {
    clearInterval(this.timerInterval)
  },
  methods: {
    async fetchExisting()
    {
      const getUpcomingConferences = functions.httpsCallable("getUpcomingConferences");
      this.$q.loading.show();
      const response = await getUpcomingConferences();
      this.upcomingConferences = response.data;
      this.$q.loading.hide();
    },
    section2Complete(direction, startTime, lengthMins, capacity, trunk)
    {
      this.scheduledStartTime = startTime;
      this.lengthMins = lengthMins;
      this.capacity = capacity;
      this.trunk = trunk;
      if (direction == 'next')
      {
        this.formPage++;
      }
      else if (direction == 'prev')
      {
        this.formPage--;
      }
    },
    async finalSectionComplete(direction, newParticipants, newAgenda)
    {
      this.participants = newParticipants;
      this.agenda = newAgenda;

      if (direction == 'next')
      {
        this.handleScheduleConference().then((id) =>
        {
          if(id)
          {
            this.$router.replace({
              name: 'Dashboard'
            });
          }
        });
      }
      else if (direction == 'start')
      {
        this.handleStartButton();
      }
      else if (direction == 'prev')
      {
        this.formPage--;
      }
    },
    handleStartButton()
    {
      if (this.liveConferences && Object.keys(this.liveConferences).length > 0)
      {
        // the user currently has a live call. Confirm that they want to stop it before continuing
        this.$q.dialog({
          title: this.$t("schedule_session.confirm_title"),
          message: this.$t("schedule_session.confirm_message"),
          ok: { label: this.$t("confirm"), flat: true, color: "negative" },
          cancel: { label: this.$t("cancel"), flat: true, color: "grey-7" },
        })
          .onOk(async () =>
          {
            this.$q.loading.show();
            const fbFunction = functions.httpsCallable("endConference");
            await fbFunction({ ConferenceId: Object.keys(this.liveConferences)[0] })
            this.$q.loading.hide();
            this.startCall();
          });
      }
      else
      {
        this.startCall();
      }
    },
    async startCall()
    {
      const newId = await this.handleScheduleConference();
      if(newId)
      {
        this.$router.replace({
          path: `begin/${newId}`,
        });
      }
    },
    async handleScheduleConference()
    {
      const scheduleConferenceFB = functions.httpsCallable("scheduleConference");
      this.$q.loading.show();

      let startTime = moment(this.scheduledStartTime);
      if(startTime.add(this.lengthMins, 'minutes') < moment())
      {
        this.$q.notify({
            type: "negative",
            message: this.$t("schedule_session.section_2.error_past"),
            multiLine: true,
          });
        return null;
      }

      try
      {
        const response = await scheduleConferenceFB({
          Name: this.name,
          Privacy: {
            AcceptContacts: this.privacySelection !== "closed",
            IsPublic: this.privacySelection === "open",
          },
          Participants: this.participants,
          Agenda: this.agenda,
          ScheduledStart: moment(this.scheduledStartTime).valueOf(),
          LengthMins: this.lengthMins,
          MaxCapacity: this.capacity,
          DropCallJoinNumber: this.trunk.caller_number
        })
        this.$q.loading.hide();
        return response.data;

      } catch (error)
      {
        this.$q.loading.hide();
        console.log(error);
        this.$q.notify({
          type: "negative",
          message: error,
        })
      }

    }
  },
  computed: {
    sessionIsNow()
    {
      if (!this.sessionTimeValid) return false;
      let start = moment(this.scheduledStartTime);
      return start < this.now && start.add(this.lengthMins, 'minutes') > this.now;
    },
    sessionTimeValid()
    {
      if (!this.scheduledStartTime || !this.lengthMins) return false;
      let start = moment(this.scheduledStartTime);
      return start.add(this.lengthMins, 'minutes') > this.now;
    }
  },
  components: {
    ScheduleSessionFormSection1,
    ScheduleSessionFormSection2,
    ScheduleSessionFormSection3,
    ScheduleSessionFormSection4,
    Toolbar
  },
};
</script>
<style>
.q-stepper__step-inner {
  padding-top: 0 !important;
}
</style>
